// Sample Program :buzzer
//		Programed by TAG. (AT-LAB)
//		times_bpBeep񐔂ZbgƎwBeeps܂B
//		gBEEP_PRI/SECAON/OFF(*1mS)time_bp_on,time_bp_offɐݒB
//		C^[o荞TXgpAuU[TYTZJE^gpB
//		times_bpɉ񐔂ނƃobNOhŃr[v܂B
#include "R8C11.h"

#define USE_TZ		// USE_TZTimerZJE^ USE_TYTimerYJE^gpw

#ifdef USE_TZ
#define	BEEP__S		SFR_TZ_S
#define	BEEP__MOD0	SFR_TZ_MOD0
#define	BEEP__CK0	SFR_TZ_CK0
#define	BEEP__CK1	SFR_TZ_CK1
#define	BEEP__WC	SFR_TZ_WC
#define	BEEP__OCNT	SFR_TZ_OCNT
#define	BEEP__OPL	SFR_TZ_OPL
#define	BEEP_PRE	SFR_PREZ
#define	BEEP_PRI	SFR_TZPR
#define	BEEP_SEC	SFR_TZSC
#endif

#ifdef USE_TY
#define	BEEP__S		SFR_TY_S
#define	BEEP__MOD0	SFR_TY_MOD0
#define	BEEP__CK0	SFR_TY_CK0
#define	BEEP__CK1	SFR_TY_CK1
#define	BEEP__WC	SFR_TY_WC
#define	BEEP__OCNT	SFR_TY_OCNT
#define	BEEP__OPL	SFR_TY_OPL
#define	BEEP_PRE	SFR_PREY
#define	BEEP_PRI	SFR_TYPR
#define	BEEP_SEC	SFR_TYSC
#endif

int time_bp_on;
int time_bp_off;
char times_bp;

char bp_flag;
int bp_counter;

void tx_int(void)
#pragma interrupt tx_int
{
	if(times_bp!=0)
	{
		if ((bp_counter--)<0)
		{
			switch(bp_flag)
			{
				case 0:
					BEEP__S=1;			// TimerCount start
					bp_counter=time_bp_on;
					bp_flag++;			// Next
					break;
				case 1:
					BEEP__S=0;			// TimerCount stop
					bp_counter=time_bp_off;
					bp_flag++;			// Next
					break;
				default:
					times_bp--;
					bp_flag=0;
					bp_counter=0;
			}
		}
	}
}

void BEEP_init(void)
{

	SFR_TCSS=0b00000000;	// TX:f1 Clock Source
	BEEP__CK0=1;
	BEEP__CK1=0;				// TZ/TY : f8 Clock source
	BEEP__MOD0=1;			// Programable Pulse mode
	BEEP__WC=1;
	BEEP__OPL=1;
	BEEP__OCNT=0;			// Timer OUT
	BEEP_PRE=16-1;
	BEEP_PRI=19;
	BEEP_SEC=18;			// f=4KHz

	SFR_TXMR=0;			// TX Timer mode for base interval
	SFR_TXIC=7;			// TX interrupt level=7
	SFR_TX=78-1;		// 1mS interval
	SFR_PREX=255;
	SFR_TX_S=1;			// TX start

	bp_flag=0;			// 荞ݓ[NtO
	bp_counter=0;		// 荞ݓ[NJE^
	time_bp_on=100;		// r[vON (100mS)
	time_bp_off=200;		// r[vOFF (200mS)
}


void main(void)
{
	BEEP_init();		// ^C}[

	ei();				// 荞݋

	times_bp=3;			// r[v 3

	while(times_bp!=0)	// r[vI҂
		;

	// r[vԁEԊuύX
	time_bp_on=300;		// r[vON (100mS)
	time_bp_off=200;		// r[vOFF (200mS)
	times_bp=5;			// r[v 5

	while(times_bp!=0)	// r[vI҂
		;
						// vOI
}

