// L[XCb`vO
// `^OlXCb` ^C}[(TX)荞ݎgp
//				Programed by TAG (AT-Lab)

#include "R8C11.h"

unsigned char key;
unsigned char key_latch;
unsigned char key_prev;

// 5mS^C}[(TX)荞
void tx_int(void)
#pragma interrupt tx_int
{
	unsigned char k,kp;

	// SW(1-3)l荞+`^Oh~
	k=SFR_P0 | 0b11110001;					// SW1-3
	kp=key;
	key=(~(k | (k ^ key_prev))) >>1;		// 2񓯂lȂSWl荞
	key_prev=k;
	key_latch=key_latch | ((key ^ kp) & key);	// SWꂽNA܂ŕێ

		// bit 7  6  5  4  3  2   1   0		key  key_latch
		//     0  0  0  0  0 SW3 SW2 SW1
}

void main(void)
{
	key_prev=0b11111111;
	key_latch=0;

	SFR_PRC_P=1;
	SFR_P0D=0b00000000;		// P0S͂ɐݒ(Zbg͓͂Ȃ̂Ŗ{KvȂ)

	SFR_P0_PUL=1;			// P0_0-3 vAbvRL

	SFR_TX_CK0=1;
	SFR_TX_CK1=0;			// TX : f8 Clock source
	SFR_TXMR=0;			// TX Timer mode for base interval
	SFR_TXIC=7;			// TX interrupt level=7
	SFR_TX=50-1;		// 5mS interval
	SFR_PREX=25-1;
	SFR_TX_S=1;			// TX start

	SFR_P3D_2=1;	// Port3_2o͂ɐݒ
	SFR_P3_2=1;		// Port3_2High(LED)ɂ
	SFR_P3D_3=1;	// Port3_3o͂ɐݒ
	SFR_P3_3=1;		// Port3_3High(LED)ɂ

	ei();			// 荞݋

	while(1)
	{
		if (key & 1)		// SW1Ă邩H
			SFR_P3_2=0;		// SW1ĂLED(P3_2)_
		else
			SFR_P3_2=1;		// SW1ĂȂLED(P3_2)

		if (key_latch & 2)			// SW2ꂽH
		{
			SFR_P3_3=SFR_P3_3 ^ 1;	// SW2ꂽuLED(P3_3)_Ԃ𔽓]
			key_latch=key_latch & 0b00000101;	// clear sw2_latch
		}
	}
}

