// Sample Program :onkai_bz
//		Programed by TAG. (AT-LAB)
//		uU[gpĊȒPȉyt܂B
//		C^[o荞TXgpAuU[TYTZJE^gpB
#include "R8C11.h"

#define USE_TZ		// USE_TZTimerZJE^ USE_TYTimerYJE^gpw

#ifdef USE_TZ
#define	BEEP__S		SFR_TZ_S
#define	BEEP__MOD0	SFR_TZ_MOD0
#define	BEEP__CK0	SFR_TZ_CK0
#define	BEEP__CK1	SFR_TZ_CK1
#define	BEEP__WC	SFR_TZ_WC
#define	BEEP__OCNT	SFR_TZ_OCNT
#define	BEEP__OPL	SFR_TZ_OPL
#define	BEEP_PRE	SFR_PREZ
#define	BEEP_PRI	SFR_TZPR
#define	BEEP_SEC	SFR_TZSC
#endif

#ifdef USE_TY
#define	BEEP__S		SFR_TY_S
#define	BEEP__MOD0	SFR_TY_MOD0
#define	BEEP__CK0	SFR_TY_CK0
#define	BEEP__CK1	SFR_TY_CK1
#define	BEEP__WC	SFR_TY_WC
#define	BEEP__OCNT	SFR_TY_OCNT
#define	BEEP__OPL	SFR_TY_OPL
#define	BEEP_PRE	SFR_PREY
#define	BEEP_PRI	SFR_TYPR
#define	BEEP_SEC	SFR_TYSC
#endif

int time_bp_on;
int time_bp_off;
char times_bp;
char note;
char octave;
char tempo;

char bp_flag;
int bp_counter;


const int onkai[]=
{			// note m[gԍɑ΂gݒl
	478,	// 0  C
	451,	// 1  C#
	426,	// 2  D
	402,	// 3  D#
	379,	// 4  E
	358,	// 5  F
	338,	// 6  F#
	319,	// 7  G
	301,	// 8  G#
	284,	// 9  A		octave1:A = 440Hz
	268,	// 10 A#
	253		// 11 B
};

const unsigned char oct_a[]=
{			//octave IN^[up̃vXP[ݒl
	40,		// 0
	20,		// 1
	10,		// 2
	5		// 3
};

typedef struct
{
	char oct;		// IN^[u (0-3)
	char note;		// ԍ (0-11) C C# D D# E F F# G G# A A# B
	int on;			//  tempo * on (mSec)
	int off;		//  tempo * off (mSec)
} SONG;

// f[^it[Yŕj
//
const SONG intro1[]=
{
	{1,4,15,1},
	{1,2,7,1},
	{1,0,7,1},
	{1,0,15,1},
	{0,9,7,1},
	{1,0,7,1},

	{1,2,15,1},
	{1,7,15,1},
	{1,0,23,9},

	{1,4,15,1},
	{1,2,7,1},
	{1,0,7,1},
	{1,0,15,1},
	{0,9,7,1},
	{1,0,7,1},

	{1,2,15,1},
	{1,4,15,1},
	{1,0,23,9},

	{0,0,0,0}			// end of array
};

const SONG intro2[]=
{
	{1,4,15,1},
	{1,2,7,1},
	{1,0,7,1},
	{1,0,15,1},
	{0,9,7,1},
	{1,0,7,1},

	{1,2,15,1},
	{1,7,15,1},
	{1,0,23,9},

	{1,4,15,1},
	{1,2,7,1},
	{1,0,7,1},
	{1,0,15,1},
	{0,9,7,1},
	{1,0,7,1},

	{1,2,15,1},
	{1,4,15,1},
	{1,0,31+16,17},

	{0,0,0,0}			// end of array
};

const SONG sabi1[]=
{
	{1,0,7,1},
	{1,0,3,1},
	{1,0,7,1},
	{1,7,7,1},
	{1,7,15,1},
	{1,5,7,1},
	{1,4,7,1},

	{1,2,11,1},
	{1,4,11,1},
	{1,5,7,1},
	{1,4,15,1},
	{1,2,15,1},

	{1,0,7,1},
	{1,0,3,1},
	{1,2,7,1},
	{1,4,7,1},
	{1,4,15,1},
	{1,2,7,1},
	{0,9,7,1},

	{1,0,7,1},
	{1,0,3,1},
	{1,0,7,1},
	{1,2,7,1},
	{1,4,15,1},
	{1,2,3,1},
	{1,0,7,5},

	{0,0,0,0}			// end of array
};

const SONG sabi2[]=
{
	{1,0,7,1},
	{1,0,3,1},
	{1,0,7,1},
	{1,7,7,1},
	{1,7,15,1},
	{1,5,7,1},
	{1,4,7,1},

	{1,2,11,1},
	{1,4,11,1},
	{1,5,7,1},
	{1,4,15,1},
	{1,2,15,1},

	{1,0,7,1},
	{1,0,3,1},
	{1,2,7,1},
	{1,4,7,1},
	{1,4,15,1},
	{1,2,7,1},
	{0,9,7,1},

	{1,0,15,1},
	{0,11,7,1},
	{1,0,7,1},
	{1,0,15,17},

	{0,0,0,0}			// end of array
};

const SONG mero1[]=
{
	{0,7,7,1},
	{1,0,7,1},
	{1,0,3,1},
	{1,0,11,1},
	{1,0,7,1},

	{1,0,7,1},
	{1,0,3,1},
	{1,0,11,1},
	{1,0,7,1},

	{1,2,11,1},
	{1,2,11,1},
	{1,4,7,1},
	{1,4,15,1+16},

	{1,0,11,1},
	{1,0,11,1},
	{1,7,7,1},
	{1,7,11,1},
	{1,5,11,1},
	{1,4,7,1},

	{1,2,11,1},
	{0,9,11,1},
	{1,0,7,1},
	{0,11,15,1+16-7},

	{0,0,0,0}			// end of array
};


const SONG mero2[]=
{
	{0,7,7,1},
	{1,0,7,1},
	{1,0,3,1},
	{1,0,11,1},
	{1,0,7,1},

	{1,0,7,1},
	{1,0,3,1},
	{1,0,11,1},
	{1,0,7,1},

	{1,2,11,1},
	{1,2,11,1},
	{1,4,7,1},
	{1,4,15,1+16},

	{1,0,11,1},
	{1,0,11,1},
	{1,7,7,1},
	{1,7,11,1},
	{1,5,11,1},
	{1,4,7,1},

	{1,4,11,1},
	{1,2,11,1},
	{1,0,7,1},
	{1,0,15,1+16},

	{0,0,0,0}			// end of array
};

const SONG mero3[]=
{
	{1,2,7,1},
	{1,2,3,1},
	{1,2,11,1},
	{1,2,7,1},

	{1,2,7,1},
	{1,2,3,1},
	{1,2,11,1},
	{1,2,7,1},

	{1,4,11,1},
	{1,2,11,1},
	{1,0,7,1},
	{1,0,15,1+16},

	{1,2,7,1},
	{1,2,3,1},
	{1,2,11,1},
	{1,2,7,1},

	{1,2,11,1},
	{1,4,11,1},
	{1,5,7,1},

	{1,5,11,1},
	{1,4,11,1},
	{1,2,7,1},
	{1,0,15,1+16},

	{0,0,0,0}			// end of array
};

const SONG mero4[]=
{
	{1,2,7,1},
	{1,2,3,1},
	{1,2,11,1},
	{1,2,7,1},

	{1,2,7,1},
	{1,2,3,1},
	{1,2,11,1},
	{1,2,7,1},

	{1,4,11,1},
	{1,2,11,1},
	{1,0,7,1},
	{1,0,15,1+16},

	{1,2,7,1},
	{1,2,3,1},
	{1,2,11,1},
	{1,2,7,1},

	{1,9,15,1},
	{1,4,7,1},
	{1,2,3,1},
	{1,0,3,1},
	{1,2,15+16,1+16+16},

	{1,2,11,1},
	{1,4,11,1},
	{1,5,7,1},
	{1,4,11+4,1},
	{1,2,3,1},
	{1,0,3,1+8},

	{0,0,0,0}			// end of array
};



void tx_int(void)
#pragma interrupt tx_int
{
	if(times_bp!=0)
	{
		if ((bp_counter--)<0)
		{
			switch(bp_flag)
			{
				case 0:
					BEEP_PRE=oct_a[octave]-1;
					BEEP_SEC=(unsigned char)(onkai[note]/2)-1;
					BEEP_PRI=(unsigned char)(onkai[note]-(onkai[note]/2))-1;
					bp_counter=time_bp_on;
					BEEP__S=1;			// TimerCount start
					bp_counter=time_bp_on;
					bp_flag++;			// Next
					break;
				case 1:
					BEEP__S=0;			// TimerCount stop
					bp_counter=time_bp_off;
					bp_flag++;			// Next
					break;
				default:
					times_bp--;
					bp_flag=0;
					bp_counter=0;
			}
		}
	}
}

//
// ^C}[
//
void BEEP_init(void)
{
	BEEP__CK0=1;
	BEEP__CK1=0;			// TZ/TY : f8 Clock source
	BEEP__MOD0=1;			// Programable Pulse mode
	BEEP__WC=1;
	BEEP__OPL=1;
	BEEP__OCNT=0;			// Timer OUT

	SFR_TX_CK0=1;
	SFR_TX_CK1=0;			// TX : f8 Clock source
	SFR_TXMR=0;			// TX Timer mode for base interval
	SFR_TXIC=7;			// TX interrupt level=7
	SFR_TX=10-1;		// 1mS interval
	SFR_PREX=250;
	SFR_TX_S=1;			// TX start

	times_bp=0;
	bp_flag=0;			// 荞ݓ[NtO
	bp_counter=0;		// 荞ݓ[NJE^
}

//
// ۂɃIN^[uAKAԁAԂSONGz񂩂ǂݏoĔ֐
//
void play(SONG *songs)
{
	while (songs->on!=0 || songs->off!=0)
	{
		time_bp_on=songs->on*tempo;		// on*tempo(mS)
		time_bp_off=songs->off*tempo;	// off*tempo(mS)
		note=songs->note;				// Kԍ(0-11) (onkai[]z`Q)
		octave=songs->oct;				// IN^[u (0-3)
		times_bp=1;

		while(times_bp!=0)
			;

		songs++;
	}
}

void main(void)
{
	BEEP_init();

	ei();			// enable interrupt

	tempo=40;

	play(sabi2);

	while(1)
	{
		play(intro1);
		play(intro2);

		play(mero1);
		play(mero2);
		play(mero3);
		play(mero4);

		play(sabi1);
		play(sabi2);
	}
						// ` Ȃ̂ł쌠Ɉ邩ȁH܂B
}

