// 7ZOgLED̃_Ci~bNXL\vO
//				Programed by TAG (AT-Lab)
// VZOgLED\܂B荞݂ŕ\ςȂ_Ci~bN_
// CӂȐl\܂BZOgf[^𒼐ڏΔCӂȕ\ł܂B

#include "R8C11.h"

unsigned char led[4];
unsigned char led_row;

const unsigned char hex2seg[]=
{
//seg  gfedcba		10or16il->ZOgϊe[u
	0b00111111,		// 0
	0b00000110,		// 1
	0b01011011,		// 2
	0b01001111,		// 3
	0b01100110,		// 4
	0b01101101,		// 5
	0b01111101,		// 6
	0b00000111,		// 7
	0b01111111,		// 8
	0b01101111,		// 9
	0b01110111,		// A
	0b01111100,		// b
	0b01011000,		// c
	0b01011110,		// d
	0b01111001,		// E
	0b01110001		// F
};


// 5mS^C}[(TX)荞
// VZOgLED led[3~0]z(ZOgPʓ_)f[^\B
// 荞݂PłPAS\ɂ20mSB(_Ci~bNXLg50Hz)
void tx_int(void)
#pragma interrupt tx_int
{
	SFR_P0=SFR_P0 | 0b00011110;		// \NA(LED\)
	SFR_P1=~led[led_row];			// \ZOgo (]ďo)
	SFR_P0=(SFR_P0 & 0b11100001) | ~(1 << (led_row+1));	// LED \ʒuo
	led_row=(led_row+1) & 3;		// \ʒu
}

// PUilSłVZOgLED̃ZOgf[^ɕϊ
void led_hex(unsigned int h)
{
	int i;

	for (i=0;i<4;i++)
	{
		led[i]=hex2seg[h & 0x0f];
		h=h >>4;
	}
}

// POilSVZOgLED̃ZOgf[^ɕϊ
void led_dec(unsigned int d)
{
	int i;
	for (i=0;i<4;i++)
	{
		led[i]=hex2seg[d % 10];
		d=d/10;
	}
}

void main(void)
{
	SFR_TX_CK0=1;
	SFR_TX_CK1=0;			// TX : f8 Clock source
	SFR_TXMR=0;			// TX Timer mode for base interval
	SFR_TXIC=7;			// TX interrupt level=7
	SFR_TX=50-1;		// 5mS interval
	SFR_PREX=250-1;
	SFR_TX_S=1;			// TX start

	SFR_P1D=0xff;		// P1 So ZOghCup
	SFR_P1=0xff;		// P1 ZOgS
	SFR_PRC_P=1;		// P0 |[gveNg
	SFR_P0D=0b00011110;	// P0_1-4 o LEDXL

	led_row=0;			// LED\s
	led[0]=led[1]=led[2]=led[3]=0;	// LEDZOg\obt@[NA

	ei();				// 荞݋

//	led_hex(0xabcd);	// 16ilLEDɕ\
	led_dec(1234);		// 10ilLEDɕ\

	while(1)
		;			// [v
}

