// L[XCb`}gbNXXLvO
//				Programed by TAG (AT-Lab)
// LCDɍĂL[}gbNX̃R[h\܂B
// 7SEGLEDɂ͐ȕ\܂BiLEDLCD͓gp͊{Iɂ͕słIj
// SW1/2/3SW00-23Ɠgp͏o܂B
// SW00-23̃L[͕ϐKeyŃrbgPʂŊ蓖ĂĂ܂B񓯎\łB
#include "R8C11.h"
#include "LCD.H"		// LCDCu`

unsigned char scan;
unsigned int key;
unsigned int key_prev;


// 5mS^C}[(TX)荞
// 荞݂1CPʂ̃XCb`󋵂LāA2񓯂lȂϐKeyɏ
void tx_int(void)
#pragma interrupt tx_int
{
	unsigned int k,km;

	SFR_P0=(SFR_P0 & 0b11100001) | ~(1 << (scan+1));	// L[XLCo

	k=( (SFR_P3_2?0:0x0001) | (SFR_P3_3?0:0x0010 ) | (SFR_P4_5?0:0x0100) ) << scan;
	km=0x0111 << scan;
	key=((key & ~km) | (k | (k ^ (key_prev & km)))) & 0x0fff;
	key_prev=(key_prev & ~km) | k;

	scan=(scan+1) & 3;				// XLCʒu
}

// 16rbglLCDHEX\֐
void LCD_hex4(unsigned int h)
{
	unsigned char ha;

	ha=(unsigned char)((h >> 12) & 0x0f)+'0';
	if (ha>'0'+9)
		ha=ha+('A'-'0'-10);
	LCD_putc(ha);
	ha=(unsigned char)((h >> 8) & 0x0f)+'0';
	if (ha>'0'+9)
		ha=ha+('A'-'0'-10);
	LCD_putc(ha);
	ha=(unsigned char)((h >> 4) & 0x0f)+'0';
	if (ha>'0'+9)
		ha=ha+('A'-'0'-10);
	LCD_putc(ha);
	ha=(unsigned char)(h & 0x0f)+'0';
	if (ha>'0'+9)
		ha=ha+('A'-'0'-10);
	LCD_putc(ha);

}

void main(void)
{
	SFR_TX_CK0=1;
	SFR_TX_CK1=0;			// TX : f8 Clock source
	SFR_TXMR=0;			// TX Timer mode for base interval
	SFR_TXIC=7;			// TX interrupt level=7
	SFR_TX=50-1;		// 5mS interval
	SFR_PREX=250-1;
	SFR_TX_S=1;			// TX start

	SFR_PRC_P=1;		// P0 |[gveNg
	SFR_P0D=0b00011110;	// P0_1-4 o LED&KEYXL SCAN0-3

	SFR_P3D_2=0;		// P3_2  SWX0
	SFR_P3D_3=0;		// P3_3  SWX1
	SFR_P4D_5=0;		// P4_5  SWX2

	scan=0;				// KEY_MTRIX ScanLine

	LCD_init();

	ei();				// 荞݋

	LCD_clear();
	LCD_puts("Key Matrix DEMO");

	while(1)
	{
		LCD_gotoXY(0,1);
		LCD_puts("KeyCode= ");
		LCD_hex4(key);
	}
}

