// L[XCb`}gbNXXLvO
//				Programed by TAG (AT-Lab)
// L[}gbNX̉ꂽL[FIFOɊi[ SW00=0 ~ SW23=11̃R[hŕԂB
// 7ZOLEDɉꂽL[ԍ\BL[ꂽƂNbN𔭐B
// ܂ɕϐKeyɌ݉ĂL[R[hi[B

#include "R8C11.h"

unsigned char led[4];
unsigned char scan;
unsigned int key;
unsigned int key_latch;
unsigned int key_prev;
unsigned char crick;
unsigned char key_buff[16];
unsigned char kb_rd_ptr;
unsigned char kb_wr_ptr;

const unsigned char hex2seg[]=
{
//seg  gfedcba		10il->ZOgϊe[u
	0b00111111,		// 0
	0b00000110,		// 1
	0b01011011,		// 2
	0b01001111,		// 3
	0b01100110,		// 4
	0b01101101,		// 5
	0b01111101,		// 6
	0b00000111,		// 7
	0b01111111,		// 8
	0b01101111,		// 9
	0b01110111,		// A
	0b01111100,		// b
	0b01011000,		// c
	0b01011110,		// d
	0b01111001,		// E
	0b01110001		// F
};


// 5mS^C}[(TX)荞
// 荞݂PłPAS\ɂ20mSB(_Ci~bNXLg50Hz)
void tx_int(void)
#pragma interrupt tx_int
{
	unsigned int k,kp,km,kx;
	unsigned char i;

	SFR_P0=SFR_P0 | 0b00011110;		// \NA(LED\)
	SFR_P1=~led[scan];				// \ZOgo (]ďo)
	SFR_P0=(SFR_P0 & 0b11100001) | ~(1 << (scan+1));	// LED \ʒuo

	k=( (SFR_P3_2?0:0x0001) | (SFR_P3_3?0:0x0010 ) | (SFR_P4_5?0:0x0100) ) << scan;
	km=0x0111 << scan;
	kp=key;
	key=((key & ~km) | (k | (k ^ (key_prev & km)))) & 0x0fff;
	key_prev=(key_prev & ~km) | k;

	if (kx=((key ^ kp) & key))	// L[ꂽH
	{
		SFR_TZ_S=1;		// uU[ON
		crick=4;

		for (i=0;i<12;i++)
		{
			if (kx & 1)
			{
				key_buff[kb_wr_ptr]=i;
				kb_wr_ptr=(kb_wr_ptr+1) & 0x0f;
			}
			kx=kx >> 1;
		}
	}

	scan=(scan+1) & 3;				// \ʒu

	if (crick!=0)
	{
		crick--;
		if (crick==0)
			SFR_TZ_S=0;		// uU[It
	}
}

// PUilSłVZOgLED̃ZOgf[^ɕϊ
void led_hex(unsigned int h)
{
	int i;

	for (i=0;i<4;i++)
	{
		led[i]=hex2seg[h & 0x0f];
		h=h >>4;
	}
}

unsigned char kb_read(void)
{
	unsigned char k;
	if (kb_rd_ptr!=kb_wr_ptr)
	{
		k=key_buff[kb_rd_ptr];
		kb_rd_ptr=(kb_rd_ptr+1) & 0x0f;
	}
	else
		k=0xff;
	return k;
}

void main(void)
{
	unsigned char k;
	unsigned int a;

	SFR_TX_CK0=1;
	SFR_TX_CK1=0;			// TX : f8 Clock source
	SFR_TXMR=0;			// TX Timer mode for base interval
	SFR_TXIC=7;			// TX interrupt level=7
	SFR_TX=50-1;		// 5mS interval
	SFR_PREX=250-1;
	SFR_TX_S=1;			// TX start

						// for BEEP
	SFR_TZ_CK0=1;
	SFR_TZ_CK1=0;				// TZ/TY : f8 Clock source
	SFR_TZ_MOD0=1;			// Programable Pulse mode
	SFR_TZ_WC=1;
	SFR_TZ_OPL=1;
	SFR_TZ_OCNT=0;			// Timer OUT
	SFR_PREZ=16-1;
	SFR_TZPR=19;
	SFR_TZSC=18;			// f=4KHz

	SFR_P1D=0xff;		// P1 So ZOghCup
	SFR_P1=0xff;		// P1 ZOgS
	SFR_PRC_P=1;		// P0 |[gveNg
	SFR_P0D=0b00011110;	// P0_1-4 o LED&KEYXL SCAN0-3

	SFR_P3D_2=0;		// P3_2  SWX0
	SFR_P3D_3=0;		// P3_3  SWX1
	SFR_P4D_5=0;		// P4_5  SWX2

	crick=0;
	kb_rd_ptr=kb_wr_ptr=0;
	scan=0;				// LED & KEY_MTRIX ScanLine
	led[0]=led[1]=led[2]=led[3]=0;	// LEDZOg\obt@[NA

	ei();				// 荞݋

	a=0;

	while(1)
	{
		if ((k=kb_read())!=0xff)
			a=(a << 4) | k;
		led_hex(a);
	}
}

