//	LCDfBXvCC\TvvO
//		Programed by TAG. (AT-LAB)
#include "R8C11.H"

#define LCD_PORT	SFR_P1
#define LCD_PORTD	SFR_P1D
#define LCD_RS		SFR_P1_6
#define LCD_E		SFR_P1_7

#define	LCD_STROBE	((LCD_E = 1),(LCD_E=0))

// 10uS҂p}N` (nl02621܂)
#define	Delay10Us(x)	{_asm("push.w R3"); _asm("mov.w #"#x"*25,R3"); _asm("sbjnz.w #1,R3,$"); _asm("pop.w R3");}

// 1mS҂֐
void DelayMs(unsigned int cnt)
{
	unsigned int i;
	for (i=0;i<cnt;i++)
		Delay10Us(100);		// 10mS҂[vJEg 10uS*100=1mS
}

// 4rbg[hLCDɏ
void lcd_write(unsigned char c)
{
	LCD_PORT=(LCD_PORT & 0xF0) |  (c >> 4);
	LCD_STROBE;
	LCD_PORT=(LCD_PORT & 0xF0) |  (c & 0x0F);
	LCD_STROBE;
	Delay10Us(4);
}

// \NA
void lcd_clear(void)
{
	LCD_RS=0;
	lcd_write(0x1);
	DelayMs(2);
}

// XgOLCD\
void lcd_puts(const char * s)
{
	LCD_RS=1;	// write characters
	while(*s)
		lcd_write(*s++);
}

// PLN^LCD\/
void lcd_putc(char c)
{
	LCD_RS=1;	// write characters
	LCD_PORT=(LCD_PORT & 0xF0) |  (c >> 4);
	LCD_STROBE;
	LCD_PORT=(LCD_PORT & 0xF0) |  (c & 0x0F);
	LCD_STROBE;
	Delay10Us(4);
}

// \ʒuw
void lcd_goto(unsigned char pos)
{
	LCD_RS=0;
	lcd_write(0x80+pos);
}

// LCD
void lcd_init(void)
{
	LCD_RS=0;	// write control bytes
	DelayMs(15);	// power on delay
	LCD_PORT=0x3;	// attention!
	LCD_STROBE;
	DelayMs(5);
	LCD_STROBE;
	Delay10Us(10);
	LCD_STROBE;
	DelayMs(5);
	LCD_PORT = 0x2;	// set 4 bit mode
	LCD_STROBE;
	Delay10Us(4);
	lcd_write(0x28);	// 4 bit mode, 1/16 duty, 5x8 font
	lcd_write(0x08);	// display off
	lcd_write(0x0F);	// display on, blink curson on
	lcd_write(0x06);	// entry mode
}

//
// CvO eXg\
//
void main(void)
{
	LCD_PORTD=0xff;		// LCDp|[gSo

	lcd_init();			// LCD

	while(1)
	{
		lcd_clear();			// ʏ
		lcd_goto(0);			// \ʒu[
		lcd_puts("LCD DEMO");
		DelayMs(1000);			// 1b҂
		lcd_goto(0);
		lcd_puts("Cݺ  ˮ");
		DelayMs(1000);
		lcd_goto(0x40);			// \ʒu[
		lcd_puts("R8C LCD Display");
		DelayMs(1000);
	}
}
