// z^_ŃvO
//  ^C}[(TimerY)PWM[hŎgpLEDPxϒ_łłB
// P3_2ɐڑĂLEDgp܂B
// TX1mS̃C^[o^C}[Ŏgp܂B
// SW1œ_ŃXs[hxASW3œ_ŃXs[h𑁂܂BSW2ŃXgbv܂B
// _ŃXs[h8iKɂȂĂ܂B
// P4_5,P3_3SW1/SW3ݒ̏܂B
// XCb`ƂLED33/LED45uԓ_AuU[(TimerZ)sbƖ܂B
// ~bgŒ_ɂȂ܂B
//				Programed by Akira Taguchi (AT-Lab)
//					modify: addition BEEP function  2004/1/15

#include "R8C11.h"

unsigned char c=0;
unsigned char d=0;	// direction
unsigned char w=0;	// stay
unsigned char s=0;	// stop

unsigned char timer;
unsigned char count;

unsigned char led33_on=0;
unsigned char led45_on=0;

unsigned char key;
unsigned char key_latch;
unsigned char key_prev;

int time_bp_on;
int time_bp_off;
char times_bp;

char bp_flag;
int bp_counter;

void tx_int(void)
#pragma interrupt tx_int
{
	unsigned char k,kp;

	// SWl荞+`^Oh~
	k=SFR_P0 | 0b11110001;
	kp=key;
	key=(~(k | (k ^ key_prev))) >>1;		// 2񓯂lȂSWl荞
	key_prev=k;
	key_latch=key_latch | ((key ^ kp) & key);	// SWꂽNA܂ŕێ

	if (led33_on!=0)
	{
		led33_on--;
		if (led33_on==0)
			SFR_P3_3=1;		// LED33 off
		else
			SFR_P3_3=0;		// LED33 on
	}

	if (led45_on!=0)
	{
		led45_on--;
		if (led45_on==0)
			SFR_P4_5=1;		// LED45 off
		else
			SFR_P4_5=0;		// LED45 on
	}

	if (count==0)
	{
		if (s==0)		// Stop Mode?
		{
			if (w==0)
			{
				if (d==0)
				{
					c++;			// 
					if (c==255)
					{
						d=1;
						w=60;		// S_̕ێ^C}[
					}
				}
				else
				{
					c--;			// 
					if (c==0)
					{
						d=0;
						w=100;		// ̕ێ^C}[
					}
				}
				SFR_TYPR=c;			// PWMݒl
				SFR_TYSC=255-c;
			}
			else
				w--;
		}
		count=timer;
	}
	else
		count--;

	if(times_bp!=0)
	{
		if ((bp_counter--)<0)
		{
			switch(bp_flag)
			{
				case 0:
					SFR_TZ_S=1;			// BEEP ON
					bp_counter=time_bp_on;
					bp_flag++;			// Next
					break;
				case 1:
					SFR_TZ_S=0;			// BEEP OFF
					bp_counter=time_bp_off;
					bp_flag++;			// Next
					break;
				default:
					times_bp--;
					bp_flag=0;
					bp_counter=0;
			}
		}
	}
}

void main(void)
{
	unsigned char speed;
	unsigned char time[]={2,3,4,5,6,7,8,9};

	speed=4;
	key_prev=0b11111111;
	key_latch=0;
	timer=time[speed];
	count=timer;

	bp_flag=0;
	bp_counter=0;
	time_bp_on=10;			// r[vON (10mS)
	time_bp_off=50;		// r[vOFF (50mS)
	times_bp=0;

	SFR_P3D_3=1;		// P3_3 Output for LED
	SFR_P3_3=1;			// LED off
	SFR_P4D_5=1;		// P4_5 Output for LED
	SFR_P4_5=1;			// LED off

	SFR_PRC_P=1;					// Protect Port Disable
	SFR_P0D=0;						// SW1-3 for Input (All Port0)
	SFR_P0_PUL=1;					// P0L Pullup

	SFR_TCSS=0b00000000;		// TX:f1 Clock Source
								// j݂WS`bvŔg``[hŎgpɂ
								// f1ݒłȂ悤łB
	SFR_TXMR=0;		// TX Timer mode for base interval
	SFR_TXIC=7;		// TX interrupt level=7
	SFR_TX=78-1;	// 1mS interval
	SFR_PREX=255;
	SFR_TX_S=1;		// TX start

	SFR_TY_CK0=1;
	SFR_TY_CK1=0;				// TY : f8 Clock source
	SFR_TYZMR=0b00000101;	// TimerY Programable Pulse mode for PWM
	SFR_PUM=0b00010000;	// PRI:H SEC:L
	SFR_TY_OCNT=0;		// TY_OUT
	SFR_PREY=10-1;		// 
	SFR_TYPR=255;
	SFR_TYSC=0;
	SFR_TY_S=1;		// TimerY start

	SFR_TZ_CK0=1;
	SFR_TZ_CK1=0;				// TZ : f8 Clock source
	SFR_TZ_MOD0=1;			// Programable Pulse mode
	SFR_TZ_WC=1;
	SFR_TZ_OPL=1;
	SFR_TZ_OCNT=0;			// Timer OUT
	SFR_PREZ=16-1;
	SFR_TZPR=19;
	SFR_TZSC=18;			// f=4KHz

	ei();

	while(1)
	{
		if (key_latch & 2)		// SW2 pushed!
		{
			s=s ^1;
			key_latch=key_latch & 0b00000101;	// clear sw2_latch
		}
		else
		if (key_latch & 1)		// SW1 pushed!
		{
			if (speed!=0)
			{
				speed--;
				timer=time[speed];
				led45_on=10;
				times_bp=1;
			}
			else
				led45_on=500;
			s=0;
			key_latch=key_latch & 0b00000110;	// clear sw1_latch
		}
		if (key_latch & 4)		// SW3 pushed!
		{
			if (speed<7)
			{
				speed++;
				timer=time[speed];
				led33_on=10;
				times_bp=1;
			}
			else
				led33_on=500;
			s=0;
			key_latch=key_latch & 0b00000011;	// clear sw3_latch
		}
	}
}


