//**************************************************************
//		LCD Library Header
//			programed by TAG. 2002/06/22
//			Please modify LCD.A30 for your LCD Unit
//**************************************************************
extern void LCD_init(void);				// LCD port initialize
extern void LCD_clear(void);			// LCD Screen clear
extern void LCD_clr_eol(void);			// clear current pos to EndOfLine
extern void LCD_cursor(char a);			// Cursor ON/BLINK ON
extern void LCD_gotoX(char x);			// Display column position(X) set
extern void LCD_gotoY(char y);			// Display row position(Y) set
extern void LCD_gotoXY(char x,char y);	// Display position(XY) set
#pragma PARAMETER LCD_gotoXY(R1L,R1H)
extern void LCD_locate(char x,char y);	// Display direct position(XY) set
#pragma PARAMETER LCD_locate(R1L,R1H)
extern void LCD_putc(unsigned char c);	// 1 Charactor write
extern void LCD_data(unsigned char c);	// 1 Charactor direct write
extern void LCD_puts(unsigned char *str);	// String write
#pragma PARAMETER LCD_puts(A0)
extern char LPOS_X;
extern char LPOS_Y;
